invoices/urls.py
from django.conf.urls import url

from invoices.views import InvoiceCancel, InvoiceCombine, InvoiceDisplay

app_name = 'invoices'
urlpatterns = [
    url(r'^combine/$', InvoiceCombine.as_view(), name='combine'),
    url(r'^(?P<reference_number>[^/]+)/$', InvoiceDisplay.as_view(),
        name='display'),
    url(r'^(?P<reference_number>[^/]+)/cancel/$', InvoiceCancel.as_view(),
        name='cancel'),
]

urls.py
from django.conf.urls import include, url


urlpatterns = [
    url(r'^badges/', include('badges.urls')),
    url(r'^bursary/', include('bursary.urls')),
    url(r'^front_desk/', include('front_desk.urls')),
    url(r'^invoices/', include('invoices.urls')),
    url(r'^news/', include('news.urls')),
    url(r'^paypal/', include('paypal.standard.ipn.urls')),
    url(r'^register/', include('register.urls')),
    url(r'^volunteers/', include('volunteers.urls')),
    url(r'', include('dc18.urls')),
    url(r'', include('wafer.urls')),
]

bursary/models.py
from collections import OrderedDict

from django.conf import settings
from django.core.exceptions import ValidationError
from django.core.mail import EmailMultiAlternatives
from django.db import models
from django.db.models import Q
from django.template.loader import render_to_string
from django.urls import reverse
from django.utils.translation import ugettext_lazy as _

from django.contrib.auth.models import Permission
from django.contrib.contenttypes.models import ContentType
from django.contrib.sites.shortcuts import get_current_site


BURSARY_STATUS_CHOICES = (
    ('submitted', 'The bursary request has been submitted'),
    ('ranked', 'The bursary request has been ranked'),
    ('pending', 'The bursary request has been granted '
                'and is pending your acceptance'),
    ('accepted', 'The bursary has been accepted'),
    ('denied', 'The bursary has been denied'),
    ('expired', 'The bursary grant has expired'),
    ('canceled', 'The bursary request has been canceled'),
)

CONTRIB_RANKING_HELP_TEXT = """

Decimal value from 0 to 5; Please try to conform to the following scale for
your assessment.

<dl>
<dt>5 "Must fund"</dt>
<dd>
If this person does not attend DebConf, there will be significant
negative impact for DebConf or Debian more generally.
</dd>
<dt>4 "Priority funding"</dt>
<dd>
There are clear benefits to Debian or to DebConf of this person attending
debconf. This might be an accepted talk that seems particularly important.
</dd>
<dt>3 "Good initiative"</dt>
<dd>
We should fund this person because they propose something interesting.
</dd>
<dt>2 "Good record"</dt>
<dd>
This person has a record of substantial contribution to Debian.this should
generally be recent contribution, i.e. within the last two years.
</dd>
<dt>1 "OK"</dt>
<dd>
If we have budget, I don't object to funding this request.
</dd>
<dt>0 "Deny"</dt>
<dd>
Even if we have budget, I think we should not fund this request.
</dd>
</dl>
"""

OUTREACH_RANKING_HELP_TEXT = """

Decimal value from 0 to 5; Please try to assess applicants according to the
following criteria, and to use the full scale across your (non-null) ratings.

<ul>
<li>Gender (favoring women (cis, trans, queer), non-binary and genderqueer
individuals, as well as trans men)</li>
<li>Age (favoring individuals over 35 years old)</li>
<li>Country of origin / ethnic diversity</li>
<li>Whether the applicant is a newcomer to Debian (yes should rank higher)</li>
</ul>

"""


class Bursary(models.Model):
    BURSARY_NEEDS = OrderedDict((
        ('unable', 'Without this funding, I will be absolutely '
                   'unable to attend'),
        ('sacrifice', 'Without the requested funding, I will have to '
                      'make financial sacrifices to attend'),
        ('inconvenient', 'Without the requested funding, attending will '
                         'be inconvenient for me'),
        ('non-financial', 'I am not applying based on financial need'),
    ))
    CAN_UPDATE_STATUSES = ('submitted', 'ranked', 'pending')
    # Linked to User rather than Attendee, so we don't lose track if someone
    # unregisters
    user = models.OneToOneField(settings.AUTH_USER_MODEL,
                                related_name='bursary',
                                on_delete=models.PROTECT)

    # Request:
    request_food = models.BooleanField()
    request_accommodation = models.BooleanField()
    request_travel = models.BooleanField()

    reason_contribution = models.TextField(blank=True)
    reason_plans = models.TextField(blank=True)
    reason_diversity = models.TextField(blank=True)
    need = models.CharField(max_length=16,
                            choices=BURSARY_NEEDS.items(), blank=True)
    travel_bursary = models.IntegerField(null=True, blank=True)
    travel_from = models.TextField(blank=True)

    # Review:
    food_status = models.CharField(max_length=32,
                                   choices=BURSARY_STATUS_CHOICES,
                                   default='submitted')
    food_accept_before = models.DateField(null=True, blank=True)

    accommodation_status = models.CharField(max_length=32,
                                            choices=BURSARY_STATUS_CHOICES,
                                            default='submitted')
    accommodation_accept_before = models.DateField(null=True, blank=True)

    travel_status = models.CharField(max_length=32,
                                     choices=BURSARY_STATUS_CHOICES,
                                     default='submitted')
    travel_accept_before = models.DateField(null=True, blank=True)

    reimbursed_amount = models.IntegerField(default=0, blank=True)

    class Meta:
        verbose_name = 'bursary request'

    @property
    def request_any(self):
        return (self.request_food or self.request_accommodation
                or self.request_travel)

    def potential_bursary(self, key=None):
        potential_bursary_status = frozenset((
            'submitted', 'ranked', 'pending', 'accepted'))
        return self.status_in(key, potential_bursary_status)

    def can_update(self, key=None):
        ret = False
        if key is None or key == 'travel':
            ret = self.request_travel and self.travel_status == 'accepted'
        return ret or self.status_in(
            key=key, statuses=self.CAN_UPDATE_STATUSES
        )

    def status_in(self, key, statuses):
        """Return boolean result for whether a bursary for key has been
        requested and is in one of the listed statuses.
        If key is None, check all possible types of bursary.
        """

        if key == 'food':
            return (self.request_food
                    and self.food_status in statuses)
        elif key == 'accommodation':
            return (self.request_accommodation
                    and self.accommodation_status in statuses)
        elif key == 'travel':
            return (self.request_travel
                    and self.travel_status in statuses)
        elif key is None:
            return (self.status_in('food', statuses)
                    or self.status_in('travel', statuses)
                    or self.status_in('accommodation', statuses))
        else:
            raise ValueError('Unknown key for status_in %s' % key)

    def must_accept(self):
        return 'pending' in (self.food_status, self.accommodation_status,
                             self.travel_status)

    def notify_status(self, request):
        if not self.request_any:
            return

        from_email = 'bursaries@debconf.org'
        to = self.user.email
        subject = ("Your bursary request for %s: status updated" %
                   get_current_site(request).name)
        body = render_to_string(
            'bursary/notify_status.txt', {
                'object': self,
                'profile_url': request.build_absolute_uri(
                    reverse('wafer_user_profile', args=(self.user.username,))
                ),
            }, request=request)

        msg = EmailMultiAlternatives(subject, body, to=[to],
                                     from_email=from_email)

        msg.send()

    def __str__(self):
        return 'Bursary <{}>'.format(self.user.username)


def validate_score(score):
    if not 0 <= score <= 5:
        raise ValidationError(
            _('%(score)s should be between 0 and 5 inclusive'),
            params={'score': score}
        )


def check_bursaryreferee_permission():
    # XXX olasd: this returns duplicates,
    #            and limit_choices_to can't do better :(

    content_type = ContentType.objects.get_for_model(BursaryReferee)
    permission = Permission.objects.get(codename='change_bursaryreferee',
                                        content_type=content_type)
    return (Q(groups__permissions=permission)
            | Q(user_permissions=permission))


class BursaryReferee(models.Model):
    bursary = models.ForeignKey(Bursary, related_name='referees',
                                on_delete=models.CASCADE)
    referee = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        on_delete=models.PROTECT,
        limit_choices_to=check_bursaryreferee_permission,
    )

    contrib_score = models.DecimalField(
        null=True, verbose_name="Contribution score",
        help_text=CONTRIB_RANKING_HELP_TEXT,
        decimal_places=2,
        max_digits=3,
        validators=[validate_score],
        blank=True,
    )

    outreach_score = models.DecimalField(
        null=True, verbose_name="Diversity and Inclusion score",
        help_text=OUTREACH_RANKING_HELP_TEXT,
        decimal_places=2,
        max_digits=3,
        validators=[validate_score],
        blank=True,
    )

    notes = models.TextField(
        default='', verbose_name="Notes for evaluation",
        help_text="Let us know how you came to your decision",
        blank=True,
    )

    final = models.BooleanField(
        default=False, verbose_name="Final assessment",
    )

    class Meta:
        unique_together = ('bursary', 'referee')

    def __str__(self):
        referee_username = '???'
        if self.referee:
            referee_username = self.referee.username
        return 'BursaryReferee <{} ({}){}>'.format(
            self.bursary.user.username,
            referee_username,
            ' final' if self.final else '',
        )

invoices/models.py
from django.conf import settings
from django.core.signing import Signer
from django.core.validators import MinValueValidator
from django.db import models
from django.dispatch import receiver
from django.urls import reverse

from paypal.standard.models import ST_PP_COMPLETED
from paypal.standard.ipn.signals import valid_ipn_received


class Invoice(models.Model):
    STATUS_CHOICES = (
        ('new', 'Invoiced'),
        ('pending', 'Payment pending'),
        ('paid', 'Payment received'),
        ('canceled', 'Invoice canceled'),
    )

    reference_number = models.CharField(max_length=128, unique=True,
                                        null=False, blank=False)
    status = models.CharField(max_length=128, choices=STATUS_CHOICES,
                              default='new')
    date = models.DateField()

    recipient = models.ForeignKey(settings.AUTH_USER_MODEL,
                                  related_name='invoices',
                                  on_delete=models.PROTECT)
    invoiced_entity = models.CharField(max_length=128, blank=True)
    billing_address = models.TextField()
    compound = models.BooleanField(default=False)

    transaction_id = models.CharField(max_length=128, null=False, blank=True)

    created = models.DateTimeField(auto_now_add=True)
    last_update = models.DateTimeField(auto_now=True)

    signer = Signer(sep=':', salt='invoices.Invoice')

    @property
    def total(self):
        return sum(line.total for line in self.lines.all())

    @property
    def total_twd(self):
        from dc18.prices import TWD_EXCHANGE_RATE
        return self.total * TWD_EXCHANGE_RATE

    def paypal_data(self):
        data = settings.PAYPAL_DATA.copy()

        data['cmd'] = '_cart'
        data['invoice'] = settings.INVOICE_PREFIX + self.reference_number
        data['upload'] = '1'

        i = 1
        for line in self.lines.all():
            if line.quantity * line.unit_price < 0:
                discount = data.get('discount_amount_cart', 0)
                discount += - (line.quantity * line.unit_price)
                data['discount_amount_cart'] = discount
                continue
            data['item_name_%d' % i] = line.description
            data['quantity_%d' % i] = line.quantity
            data['amount_%d' % i] = line.unit_price
            i = i + 1

        return data

    def text_details(self):
        header = ('Reference', 'Description', 'Qty', 'Unit', 'Total')
        footer = ('', '', '', 'Total', str(self.total))
        lines = [
            (line.reference, line.description, line.quantity, line.unit_price,
             line.total)
            for line in self.lines.all()
        ]
        all_lines = (
            [
                header,
                ('', '', '', '', ''),
            ]
            + lines
            + [
                ('', '', '', '-------', '-------'),
                footer,
            ]
        )

        col_width = [max(len(str(x)) for x in col) for col in zip(*all_lines)]
        formats = ['{:{}}'] * 3 + ['{:>{}}'] * 2
        return "\n".join(
            ("| " + " | ".join(formats[i].format(x, col_width[i])
                               for i, x in enumerate(line)) + " |")
            for line in all_lines
        )

    def save(self, *args, **kwargs):
        # generate reference number on save
        if not self.reference_number:
            year = str(self.date.year)
            last_invoice = Invoice.objects.filter(
                reference_number__startswith=year
            ).order_by('-reference_number').first()

            if last_invoice:
                year, seqnum = last_invoice.reference_number.split('-')
                seqnum = int(seqnum, 10) + 1
            else:
                seqnum = 1

            self.reference_number = '%s-%05d' % (year, seqnum)

        return super().save(*args, **kwargs)

    def get_absolute_url(self):
        return reverse(
            'invoices:display',
            kwargs={'reference_number': self.reference_number})

    def get_signed_url(self):
        signed_reference = self.signer.sign(self.reference_number)
        return reverse(
            'invoices:display',
            kwargs={'reference_number': signed_reference})


@receiver(valid_ipn_received)
def update_invoice_on_ipn_received(sender, **kwargs):
    ipn = sender
    paypal_data = settings.PAYPAL_DATA
    if ipn.payment_status == ST_PP_COMPLETED:
        if ipn.receiver_email != paypal_data['business']:
            return
        if not ipn.invoice.startswith(settings.INVOICE_PREFIX):
            return

        invoice_number = ipn.invoice[len(settings.INVOICE_PREFIX):]
        invoice = Invoice.objects.get(reference_number=invoice_number)
        invoice.status = 'paid'
        invoice.transaction_id = ipn.txn_id
        invoice.save()

        if invoice.compound:
            for line in invoice.lines.all():
                reference = line.reference.split('#', 1)[1]
                child_invoice = Invoice.objects.get(reference_number=reference)
                child_invoice.status = 'paid'
                child_invoice.transaction_id = ipn.txn_id
                child_invoice.save()


class InvoiceLine(models.Model):
    invoice = models.ForeignKey(Invoice, related_name='lines',
                                on_delete=models.CASCADE)
    line_order = models.IntegerField()
    reference = models.CharField(max_length=32)
    description = models.CharField(max_length=1024)
    unit_price = models.DecimalField(max_digits=8, decimal_places=2)
    quantity = models.IntegerField(validators=[MinValueValidator(1)])

    @property
    def total(self):
        return self.unit_price * self.quantity

    class Meta:
        unique_together = ('invoice', 'line_order')
        ordering = ('invoice', 'line_order')

    def __str__(self):
        return 'InvoiceLine(%s [%s] %d @ %.02f = %.02f)' % (
            self.reference,
            self.description,
            self.quantity,
            self.unit_price,
            self.total,
        )

templates/wafer.users/profile.html
{% extends "wafer/base.html" %}
{% load i18n %}
{% block title %}{{ object.userprofile.display_name }} - {{ WAFER_CONFERENCE_NAME }}{% endblock %}
{% block main_class %}profile{% endblock %}
{% block content %}
{% with profile=object.userprofile %}
<section>
  <div class="row">
    <div class="col-md-2 text-center" id="profile-avatar">
      {% with profile.avatar_url as avatar_url %}
        {% if avatar_url != None %}
          <img src="{{ profile.avatar_url }}">
        {% endif %}
      {% endwith %}
      {% if can_edit %}
        <a class="btn btn-secondary btn-sm" href="#" rel="popover" data-toggle="popover"
           data-title="{% trans 'Changing your mugshot' %}" data-html="true"
           data-placement="bottom">{% trans 'Edit Mugshot' %}</a>
        <div class="popover-contents">
          {% blocktrans %}
            Pictures provided by <a href="https://www.libravatar.org/">libravatar</a>
            (which falls back to <a href="https://secure.gravatar.com/">Gravatar</a>).<br>
            Change your picture there.
          {% endblocktrans %}
        </div>
      {% endif %}
    </div>
    <div class="col-md">
      {% spaceless %}
        <h1>
          {% if profile.homepage %}
            <a href="{{ profile.homepage_url }}">
          {% endif %}
          {{ profile.display_name }}
          {% if profile.homepage %}
            </a>
          {% endif %}
        </h1>
        {% if profile.twitter_handle %}
          <p>
            <a href="https://twitter.com/{{ profile.twitter_handle }}" class="twitter-follow-button" data-show-count="false">
              {% blocktrans with handle=profile.twitter_handle %}Follow @{{ handle }}{% endblocktrans %}
            </a>
          </p>
        {% endif %}
        {% if profile.github_username %}
          <p>
            <a href="https://github.com/{{ profile.github_username }}">
              {% blocktrans with username=profile.github_username %}GitHub: {{ username }}{% endblocktrans %}
            </a>
          </p>
        {% endif %}
      {% endspaceless %}
    </div>
    {% if can_edit %}
      <div class="col-md-3">
        <div class="list-group">
          <a href="{% url 'wafer_user_edit' object.username %}" class="list-group-item list-group-item-action">{% trans 'Edit User' %}</a>
          <a href="{% url 'wafer_user_edit_profile' object.username %}" class="list-group-item list-group-item-action">{% trans 'Edit Profile' %}</a>
          {% if WAFER_REGISTRATION_OPEN %}
            {% if profile.is_registered %}
              <a href="{% url 'register' %}" class="list-group-item list-group-item-action">{% trans 'Update Registration' %}</a>
              <a href="{% url 'badges.own' %}" class="list-group-item list-group-item-action">{% trans 'Preview my badge' %}</a>
              <a href="{% url 'unregister' %}" class="list-group-item list-group-item-action">{% trans 'Unregister' %}</a>
            {% else %}
              <a href="{% url 'register' %}" class="list-group-item list-group-item-action">{% trans 'Register' %}</a>
            {% endif %}
          {% endif %}
          <a href="{% url 'wafer_talk_submit' %}" class="list-group-item list-group-item-action">{% trans 'Submit Talk Proposal' %}</a>
        </div>
      </div>
    {% endif %}
  </div>
  {% if profile.bio %}
    <div class="bio">
      {{ profile.bio|linebreaks }}
    </div>
  {% endif %}
  {% if can_edit %}
    {% with attendee=object.attendee %}
      {% if attendee.billable and not attendee.paid %}
        <div class="alert alert-danger">
          Not paid.
          {% if attendee.new_invoices.exists %}
            <a href="#my-invoices">My Invoices</a>
          {% else %}
            <a class="btn btn-primary" href="{% url 'register' %}">Finish Registration</a>
          {% endif %}
        </div>
      {% endif %}
    {% endwith %}
    {% if profile.pending_talks.exists or profile.accepted_talks.exists or profile.provisional_talks.exists%}
      {% if profile.is_registered %}
        <div class="alert alert-success">
          {% blocktrans %}
            Registered
          {% endblocktrans %}
        </div>
      {% else %}
        <div class="alert alert-danger">
          {% blocktrans %}
            <strong>WARNING:</strong>
            Talk proposal submitted, but speaker hasn't registered to attend.
          {% endblocktrans %}
          {% if WAFER_REGISTRATION_OPEN %}
            {% trans "Register now!" %}
          {% endif %}
        </div>
      {% endif %}
    {% endif %}
  {% endif %}
</section>
{# Accepted talks are globally visible #}
{% if profile.accepted_talks.exists %}
  <section>
    <h2>{% trans 'Accepted Talks:' %}</h2>
    {% for talk in profile.accepted_talks %}
      <div class="card">
        <div class="card-body">
          <h3 class="card-title">
            <a href="{{ talk.get_absolute_url }}">
              {{ talk.title }}
            </a>
          </h3>
          <p>{{ talk.abstract.rendered|safe }}</p>
        </div>
      </div>
    {% endfor %}
  </section>
{% endif %}
{% if profile.cancelled_talks.exists %}
  <section>
    <h2>{% trans 'Cancelled Talks:' %}</h2>
    {% for talk in profile.cancelled_talks %}
      <div class="card">
        <div class="card-body">
          <h3 class="card-title">
            <a href="{{ talk.get_absolute_url }}">
              {{ talk.title }}
            </a>
          </h3>
          <p>{{ talk.abstract.rendered|safe }}</p>
        </div>
      </div>
    {% endfor %}
  </section>
{% endif %}
{% if profile.provisional_talks.exists %}
  <section>
    <h2>{% trans 'Provisionally Accepted Talks:' %}</h2>
    {% for talk in profile.provisional_talks %}
      <div class="card">
        <div class="card-body">
          <h3 class="card-title">
            <a href="{{ talk.get_absolute_url }}">
              {{ talk.title }}
            </a>
          </h3>
          <p>{{ talk.abstract.rendered|safe }}</p>
        </div>
      </div>
    {% endfor %}
  </section>
{% endif %}
{# Submitted talk proposals are only visible to the owner #}
{% if can_edit %}
  {% if profile.pending_talks.exists %}
    <section>
      <h2>{% trans 'Submitted or Under Consideration Talks:' %}</h2>
      {% for talk in profile.pending_talks %}
        <div class="card">
          <div class="card-body">
            {% comment %}
            Because this is one of the author's pending talks, we don't need to
            check for edit permission's on the talk explictly. This doesn't show
            the edit button for people with 'change-talk' permissions, but we
            accept that tradeoff for simplicity here.
            {% endcomment %}
            <a href="{% url 'wafer_talk_edit' talk.pk %}"
               class="float-right btn btn-secondary btn-lg">
              {% trans 'Edit' %}
            </a>
            <h3 class="card-title">
              <a href="{{ talk.get_absolute_url }}">
                {{ talk.title }}
              </a>
            </h3>
            <p>{{ talk.abstract.rendered|safe }}</p>
          </div>
        </div>
      {% endfor %}
    </section>
  {% endif %}
{% endif %}
{% if can_edit and object.bursary and object.bursary.request_any %}
  <section>
    {% with bursary=object.bursary %}
      <h2>{% trans 'My bursary requests:' %}</h2>
      <div class="card-group">
        <div class="card">
          <div class="card-header">
            <h3>{% trans 'Food' %}</h3>
          </div>
          <div class="card-body">
            {% if bursary.request_food %}
              <p>{{ bursary.get_food_status_display }}</p>
              {% if bursary.can_update and bursary.food_status == 'pending' %}
                <p class="alert alert-success">
                  {% blocktrans with date=bursary.food_accept_before|date %}
                    Your bursary has been granted.
                    You need to confirm it before {{ date }}.
                  {% endblocktrans %}
                </p>
              {% endif %}
            {% else %}
              <div>{% trans 'Not Requested' %}</div>
            {% endif %}
          </div>
        </div>
        <div class="card">
          <div class="card-header">
            <h3>{% trans 'Accommodation' %}</h3>
          </div>
          <div class="card-body">
            {% if bursary.request_accommodation %}
              <p>{{ bursary.get_accommodation_status_display }}</p>
              {% if bursary.can_update and bursary.accommodation_status == 'pending' %}
                <p class="alert alert-success">
                  {% blocktrans with date=bursary.accommodation_accept_before|date %}
                    Your bursary has been granted.
                    You need to confirm it before {{ date }}.
                  {% endblocktrans %}
                </p>
              {% endif %}
            {% else %}
              <div>{% trans 'Not Requested' %}</div>
            {% endif %}
          </div>
        </div>
        <div class="card">
          <div class="card-header">
            <h3>{% trans 'Travel' %}</h3>
          </div>
          <div class="card-body">
            {% if bursary.request_travel %}
              <p>{{ bursary.get_travel_status_display }}</p>
              <table>
                <tr>
                  <th>{% trans 'Requested' %}</th>
                  <td>{{ bursary.travel_bursary }} USD</td>
                </tr>
                <tr>
                  <th>{% trans 'Reimbursed' %}</th>
                  <td>{{ bursary.reimbursed_amount }} USD</td>
                </tr>
              </table>
              {% if bursary.can_update and bursary.travel_status == 'pending' %}
                <p class="alert alert-success">
                  {% blocktrans with date=bursary.travel_accept_before|date %}
                    Your bursary has been granted.
                    You need to confirm it before {{ date }}.
                  {% endblocktrans %}
                </p>
              {% endif %}
            {% else %}
              <div>{% trans 'Not Requested' %}</div>
            {% endif %}
          </div>
        </div>
      </div>

      {% if bursary.can_update %}
        {% if bursary.must_accept %}
          <p><a href="{% url 'bursary_update' %}" class="btn-lg btn btn-primary btn-success">{% trans 'Accept my bursary' %}</a></p>
        {% else %}
          <p><a href="{% url 'bursary_update' %}" class="btn-lg btn btn-primary">{% trans 'Update my bursary request' %}</a></p>
        {% endif %}
      {% endif %}
    {% endwith %}
  </section>
{% endif %}
{% if can_edit and object.invoices.exists %}
  <section>
    {% with invoices=object.invoices.all %}
      <h2 id="my-invoices">{% trans 'My invoices:' %}</h2>
      <div class="card-group">
        {% for invoice in invoices %}
          <div class="card">
            <div class="card-header">
              <h3 class="card-title">#{{ invoice.reference_number }}</h3>
            </div>
            <div class="card-body">
              <div>Total: {{ invoice.total }} USD / {{ invoice.total_twd }} TWD</div>
              <div>Status: {{ invoice.get_status_display }}</div>
              <div><a class='btn btn-outline-primary' href="{% url "invoices:display" reference_number=invoice.reference_number%}">Display</a></div>
            </div>
          </div>
        {% endfor %}
      </div>
    {% endwith %}
  </section>
{% endif %}
{% with accomm=object.attendee.accomm %}
  {% if can_edit and accomm %}
    <section>
      <h2 id="my-accomm">{% trans 'My accommodation' %}</h2>
      <div class="card-group">
        <div class="card">
          <div class="card-header">
            <h3 class="card-title">
              Nights
            </h3>
          </div>
          <div class="card-body">
            <ul>
              {% for night in accomm.nights.all %}
                <li>Night of {{ night }}</li>
              {% endfor %}
            </ul>
            <div class="small">The night of is the night after the date specified.</div>
          </div>
        </div>

        <div class="card">
          <div class="card-header">
            <h3 class="card-title">
              Room {{ accomm.room }}
            </h3>
          </div>
          <div class="card-body">
            <div>Roommates:</div>
            <ul>
              {% for mate in accomm.get_roommates %}
                <li>{{ mate.user.userprofile.display_name }}</li>
              {% endfor %}
            </ul>
          </div>
        </div>
      </div>
    </section>
  {% endif %}
{% endwith %}
{% endwith %}
{% endblock %}
{% block extra_foot %}
  <script type="text/javascript">
    {% if profile.twitter_handle %}
    // Twitter boilerplate
    !function(d, s, id) {
      var js, fjs = d.getElementsByTagName(s)[0];
      if (! d.getElementById(id)) {
        js = d.createElement(s);
        js.id = id;
        js.src = "//platform.twitter.com/widgets.js";
        fjs.parentNode.insertBefore(js, fjs);
      }
    }(document, "script", "twitter-wjs");
    {% endif %}

    $("#profile-avatar [rel=popover]").attr("data-content", $("#profile-avatar .popover-contents").html());
    $("a[rel=popover]").popover();
  </script>
{% endblock %}